aboutsummaryrefslogtreecommitdiff
path: root/contrib
diff options
context:
space:
mode:
authorDiego Novillo <dnovillo@google.com>2011-06-24 09:11:31 -0400
committerDiego Novillo <dnovillo@gcc.gnu.org>2011-06-24 09:11:31 -0400
commit23d11384dbf3b04e5dcbcf349bf34308ab8ec9ef (patch)
tree4e563b9913149b01929a180b5d03b7c9e0885a97 /contrib
parent219441f2b86850b9fd2d4bc997f1162724605dd4 (diff)
downloadgcc-23d11384dbf3b04e5dcbcf349bf34308ab8ec9ef.zip
gcc-23d11384dbf3b04e5dcbcf349bf34308ab8ec9ef.tar.gz
gcc-23d11384dbf3b04e5dcbcf349bf34308ab8ec9ef.tar.bz2
* repro_fail: New.
From-SVN: r175374
Diffstat (limited to 'contrib')
-rw-r--r--contrib/ChangeLog4
-rwxr-xr-xcontrib/repro_fail82
2 files changed, 86 insertions, 0 deletions
diff --git a/contrib/ChangeLog b/contrib/ChangeLog
index f01d576..178a732 100644
--- a/contrib/ChangeLog
+++ b/contrib/ChangeLog
@@ -1,3 +1,7 @@
+2011-06-24 Diego Novillo <dnovillo@google.com>
+
+ * repro_fail: New.
+
2011-06-21 Joseph Myers <joseph@codesourcery.com>
* gcc_update (gcc/config/avr/avr-tables.opt): New dependencies.
diff --git a/contrib/repro_fail b/contrib/repro_fail
new file mode 100755
index 0000000..8100456
--- /dev/null
+++ b/contrib/repro_fail
@@ -0,0 +1,82 @@
+#!/bin/bash -eu
+#
+# Script to reproduce a test failure from a dejagnu .log file.
+#
+# Contributed by Diego Novillo <dnovillo@google.com>
+#
+# Copyright (C) 2011 Free Software Foundation, Inc.
+#
+# This file is part of GCC.
+#
+# GCC is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# GCC is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING. If not, write to
+# the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+# Boston, MA 02110-1301, USA.
+
+# This script will search a line starting with 'spawn' that includes the
+# pattern you are looking for (typically a source file name).
+#
+# Once it finds that pattern, it re-executes the whole command
+# in the spawn line. If the pattern matches more than one spawn
+# command, it asks which one you want.
+
+if [ $# -lt 2 ] ; then
+ echo "usage: $0 pattern file.log [additional-args]"
+ echo
+ echo "Finds the 'spawn' line matching PATTERN in FILE.LOG and executes"
+ echo "the command with any arguments in ADDITIONAL-ARGS."
+ echo
+ exit 1
+fi
+
+pattern="$1"
+logf="$2"
+shift 2
+
+# Find the commands in LOGF that reference PATTERN.
+lines=$(grep -E "^spawn .*$pattern" $logf | sed -e 's/^spawn //')
+if [ -z "$lines" ] ; then
+ echo "Could not find a spawn command for pattern $pattern"
+ exit 1
+fi
+
+# Collect all the command lines into the COMMANDS array.
+old_IFS="$IFS"
+IFS=" "
+num_lines=0
+for line in $lines ; do
+ num_lines=$[$num_lines + 1]
+ echo "[$num_lines] $line"
+ commands[$num_lines]=$line
+done
+
+# If we found more than one line for PATTERN, ask which one we should run.
+cmds_to_run='0'
+if [ $num_lines -gt 1 ] ; then
+ echo
+ echo
+ echo -n "Enter the list of commands to run or '0' to run them all: "
+ read cmds_to_run
+fi
+if [ "$cmds_to_run" = "0" ] ; then
+ cmds_to_run=$(seq 1 $num_lines)
+fi
+IFS="$old_IFS"
+
+# Finally, execute all the commands we were told to execute.
+for cmd_num in $cmds_to_run ; do
+ cmd=${commands[$cmd_num]}
+ set -x +e
+ $cmd "$@"
+ set +x -e
+done